﻿/*
 * Name: CntLogic.js
 * Author: r.mundt 
 * Uri: http://www.bitrokkertools.org
 * Description: The logic of 'Cnt'.
 * Version 1.0
 * License: GPLv3
 * Copyright (C) 2013
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

var CNT;
// cnt class
function CntClass(Day, Month, Year, Hour, Minute, Second, EventText, PromoText) {
    // private member
    var _eTime = new Date(Year, Month - 1, Day, Hour, Minute, Second);
    // public member
    this.EventString = EventText;
    this.PromoString = PromoText;
    this.ScrollString = new String("");
    this.EventTime = _eTime.getTime() / 1000;
    this.CntTimer = new Object();
    this.CntTimerFinal = new Object();
    this.CntTimerPromo = new Object();
}

// write on cnt display
function PrintOnDisplay(DisplayText) {
	document.getElementById('BlockDay1').innerHTML = DisplayText.charAt(0);
	document.getElementById('BlockDay2').innerHTML = DisplayText.charAt(1);
	document.getElementById('BlockHour1').innerHTML = DisplayText.charAt(2);
	document.getElementById('BlockHour2').innerHTML = DisplayText.charAt(3);
	document.getElementById('BlockMinute1').innerHTML = DisplayText.charAt(4);
	document.getElementById('BlockMinute2').innerHTML = DisplayText.charAt(5);
	document.getElementById('BlockSecond1').innerHTML = DisplayText.charAt(6);
	document.getElementById('BlockSecond2').innerHTML = DisplayText.charAt(7);
}

// calculate the cnt string
function CntClock() {
    var _dt = new Date();
    var _cT = _dt.getTime() / 1000;
    // calculate days, hours, mins...
    var _cD = (CNT.EventTime - _cT) / 60 / 60 / 24;
    var _cH = (_cD % 1) * 24;
    var _cM = (_cH % 1) * 60;
    var _cS = (_cM % 1) * 60;
    var _r = new String();
    // check is cnt up
    if (_cD <= 0 && _cH <= 0 && _cM <= 0 && _cS <= 0) {
        window.clearInterval(CNT.CntTimer);
        Final_Timer();        
    }
    else {
        _r = SetDisplayFormat(_cD);
        _r += SetDisplayFormat(_cH);
        _r += SetDisplayFormat(_cM);
        _r += SetDisplayFormat(_cS);
    }
    return _r.toString();
}

// correction the displayed format
function SetDisplayFormat(Value) {
    Value = Math.floor(Value);
    if (Value < 10)
        Value = "0" + Value;
    else if (Value > 99)
        Value = "--";
    return Value.toString();
}

// cut and set string for scrolling 
function SetScrollFormat(DisplayText) {
    if (CNT.ScrollString.length == 0)
        CNT.ScrollString = DisplayText;
    else
        CNT.ScrollString = CNT.ScrollString.slice(1, CNT.ScrollString.length);
    return CNT.ScrollString;
}

// set date time format for object
function SetDateTimeFormat(EventDateTime) {
    var _r = new Array(6);
    _r[0] = EventDateTime.substr(0, 2);
    _r[1] = EventDateTime.substr(3, 2);
    _r[2] = EventDateTime.substr(6, 4);
    _r[3] = EventDateTime.substr(11, 2);
    _r[4] = EventDateTime.substr(14, 2);
    _r[5] = EventDateTime.substr(17, 2);
    return _r;
}

// check if params sets
function IsParameterSet(EventDateTime, EventText, PromoText) {
    var _r = new Array(false, false, false);
    if (EventDateTime && EventDateTime.length == 19 && typeof (EventDateTime) == 'string') {
        _r[0] = true;
    }
    if (EventText && typeof (EventText) == 'string') {
        _r[1] = true;
    }
    if (PromoText && typeof (PromoText) == 'string') {
        _r[2] = true;
    }
    return _r;
}

// cnt event
function Cnt_Event() {
    PrintOnDisplay(CntClock());
}

// final event
function Final_Event() {
    PrintOnDisplay(SetScrollFormat(CNT.EventString));
}

// promo event
function Promo_Event() {
    PrintOnDisplay(SetScrollFormat(CNT.PromoString));
    if (CNT.ScrollString.length < 9) {
        window.clearInterval(CNT.CntTimerPromo);
        CNT.ScrollString = "";
        // set cnt timer
        CNT.CntTimer = window.setInterval('Cnt_Event()', 1000);
    }
}

// set promo timer
function Promo_Timer() {    
    CNT.CntTimerPromo = window.setInterval('Promo_Event()', 600);
}

// set final timer
function Final_Timer() {
    CNT.CntTimerFinal = window.setInterval('Final_Event()', 800);
}

// first function to call
function CntStart(EventDateTime, EventText, PromoText) {
    // alternative drawing cnt display table add '<div id="CntSpacer" />'
    //CntSpacer.innerHTML = '<table border="0px" class="CntLayout"><tr class="CntHeader"><td colspan="2">TAG</td><td colspan="2">STUNDE</td><td colspan="2">MINUTE</td><td colspan="2">SEKUNDE</td></tr><tr class="CntDisplay"><td id="BlockDay1"></td><td id="BlockDay2"></td><td id="BlockHour1"></td><td id="BlockHour2"></td><td id="BlockMinute1"></td><td id="BlockMinute2"></td><td id="BlockSecond1"></td><td id="BlockSecond2"></td></tr></table>';
    // init. display
    PrintOnDisplay("--------");
    // check is params correctly sets
    var params = IsParameterSet(EventDateTime, EventText, PromoText);
    if (params[0] && params[1]) {
        var _d = SetDateTimeFormat(EventDateTime);
        // check if promo sets
        if (params[2]) {
            // init. cnt object with promo
            CNT = new CntClass(_d[0], _d[1], _d[2], _d[3], _d[4], _d[5], EventText, PromoText);
            Promo_Timer();
        }
        else {
            // init. cnt object without promo
            CNT = new CntClass(_d[0], _d[1], _d[2], _d[3], _d[4], _d[5], EventText, "");
            CNT.CntTimer = window.setInterval('Cnt_Event()', 1000);
        }
    }
    else {
        PrintOnDisplay("INIT?ERR");
    }
}